import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.filter.*;

import java.util.*;
import java.awt.image.*;
import java.awt.color.*;

/** 22/05/02 E. Glory
    Opponent colors are issue of Hering theorie (1964)
    1st component= Red/Green             (R-G)
    2nd component= Yellow/Blue           (2B-R-G)
    3rd component= Black/White           (R+G+B)
    ->The Colour Image Processsing Handbook, (Sangwine,Horne) p73-75
*/

public class fromRGBtoOpp_ implements PlugInFilter {
	ImagePlus imp;
        public  int [] Pixels;

  
	public int setup(String arg, ImagePlus imp) {
	  	this.imp = imp;
		int h=imp.getHeight();
		int w=imp.getWidth();			
		this.Pixels=new int[h*w];	
		return DOES_RGB+NO_CHANGES;
	}

	public void run(ImageProcessor ip) {
		Pixels=(int[])ip.getPixels();
		stackOpp(ip);

	}

   	public void stackOpp(ImageProcessor ip) {
	        IJ.showProgress(0.1);

	        String title=imp.getTitle();
		String name=title.substring(0,title.indexOf("."));

                byte[] RG=new byte[this.Pixels.length];
		byte[] YB=new byte[this.Pixels.length];
		byte[] WB=new byte[this.Pixels.length];

		this.getOpp(RG,YB,WB);

		ImagePlus imp2=new ImagePlus(imp.getTitle(), ip);

		//create stack and select X channel
		ColorModel cm = LookUpTable.createGrayscaleColorModel(false);
		ImageStack stack = new ImageStack(imp.getWidth(),imp.getHeight(), cm);
		stack.addSlice(name+"_RG",RG);
		stack.addSlice(name+"_YB",YB);
		stack.addSlice(name+"_WB",WB);
		//System.out.println("nombre de slices "+stack.getSize());
		IJ.showProgress(1.0);
		imp2.setStack(null, stack);
    		imp2.show();
	}

         public void getOpp(byte[] RG, byte[] YB, byte[] WB) {
	        int c,R,G,B;
		float[] Opp = new float[3];
		for (int i=0; i < Pixels.length; i++) {
		  c = Pixels[i];
		  R = (c&0xff0000)>>16;
		  G = (c&0xff00)>>8;
		  B = c&0xff;
		  Opp=RGBtoOpp(R,G,B,Opp);
		  RG[i] = (byte)((int)(Opp[0]/2f+127.5f));
		  YB[i] = (byte)((int)(Opp[1]*255f/1020f+127.5f));
		  WB[i] = (byte)((int)(Opp[2]/3f));
	
		}
	 }


         public float[] RGBtoOpp(int R, int G, int B, float[] Oppvals){
	       if (Oppvals==null)
    		  Oppvals =new float[3];
	       
	       Oppvals[0]=R-G;                 // [-255;255]
	       Oppvals[1]=2f*B-R-G;            // [-510;510]
	       Oppvals[2]=R+G+B;               // [0;765]
	       return Oppvals;
	 }

}


